// RecDataRecord implementation
#include <iostream>
using namespace std;

#include "RecDataRecord.h"

ClassImp(RecDataRecord)

void RecDataRecord::AdoptComponent(TObject* component) {
  // Adopt (to own) data block.

  fComponents.Add(component);
  
}

void RecDataRecord::Init() {
  // Initialization performed at record construction
  //
  fComponents.SetOwner(true);
}

RecDataRecord::RecDataRecord() : fComponents() {
  // Default constructor
  Init();
}

RecDataRecord::~RecDataRecord() {
  // Destructor

  fComponents.Delete();
}

  
void  RecDataRecord::Print(Option_t* /* option */) const {
  //
  //  Purpose:  Print record in form supported by TObject::Print.
  //
  //  Arguments: option (not used)
  //
  //  Return:  none.
  //
  //  Contact:   S. Kasahara
  //

  cout << "RecDataRecord:" << endl;

  Int_t ncomponents = fComponents.GetEntriesFast();
  cout << "\nHas " << ncomponents << " component";
  if ( ncomponents > 1 ) cout << "s:" << endl;
  else if ( ncomponents == 1 ) cout << ":" << endl;
  else {
    cout << "s." << endl;
    cout << endl;
    return;
  }

  TObjArrayIter itr(&fComponents);
  Int_t ient = 0;
  while ( TObject *id = itr() ) {
    cout << "  " << ient << ")" << " ClassName " << id->ClassName();
    TObjArray* array = dynamic_cast<TObjArray*>(id);
    if (array) {
      cout << ", array has " << array -> GetEntriesFast() << " entries." << endl;
      TObjArrayIter itr(array);
      while ( TObject* arrayobj = itr() ) {
        cout << "\t";
	arrayobj -> Print();
      }
    }
    else {
      cout << ", ";
      id -> Print();
    }
    
    ient++;
  }
  cout << endl;
  
  return;

}

  
  

  

    
  
