#ifndef SIGNAL_H
#define SIGNAL_H

#include <map>
#include "TObject.h"
#include "Hit.h"

class Signal : public TObject {

 public:

   Signal() {}
   virtual ~Signal() { fHits.clear(); }
   void AddHit(const Hit* hit, Double_t weight = 1) 
     { fHits[hit] = weight; }
   
       
   void                     Print(Option_t *option = "") const;

 private:

   std::map<const Hit*,Float_t> fHits; // ptrs not owned

   ClassDef(Signal,1)  

};

#endif
