{
// usage: root[0] .x testwrt.C

gSystem -> Load("libReco.so");

f = new TFile("simtest.root","RECREATE");
t = new TTree("Sim","Sim Test");

SimRecord* record = 0;
t -> Branch("SimRecord","SimRecord",&record,32000,99);
t -> Print();

for ( int i = 0; i < 5; i++ ) {
  record = new SimRecord();
  TClonesArray* newarr = new TClonesArray("Hit",100);
  Signal* signal = new Signal();
  for ( int ihit = 0; ihit < 10; ihit++ ) {
    Hit* hit = new ((*newarr)[ihit]) Hit(ihit,ihit,ihit);
    if (ihit%2 == 0) signal -> AddHit(hit); // store even number hits
  }
  record -> AdoptComponent(newarr); // adopt to own
  record -> AdoptComponent(signal); // adopt to own

  Int_t nbytes = t -> Fill();
  cout << "Filled entry " << i << " with " << nbytes << " bytes." << endl;
  record -> Print();
  delete record; record = 0;
  gObjectTable -> Print();
}

t -> Write();
f -> Close();

}


